﻿using Syncfusion.XForms.Buttons;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SimpleSample
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            ViewModel viewModel = new ViewModel();
           
            StackLayout layout = new StackLayout();
            
            foreach(Model model in viewModel.Data)
            {
               var binding = new Binding()
                {
                    Source = model,
                    Path = "IsChecked",
                    Mode = BindingMode.TwoWay
                };

                Binding textbinding = new Binding()
                {
                    Source = model,
                    Path = "Name",
                    Mode = BindingMode.TwoWay
                };

                SfCheckBox sfCheckBox = new SfCheckBox();
                sfCheckBox.SetBinding(SfCheckBox.TextProperty, textbinding);
                sfCheckBox.SetBinding(SfCheckBox.IsCheckedProperty, binding);
                layout.Children.Add(sfCheckBox);
            }

            this.Content = layout;            
        }

    
    }

    public class ViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<Model> Data { get; set; }

        public ViewModel()
        {
            Data = new ObservableCollection<Model>()
            {
                new Model { Name = "David", IsChecked = true },
                new Model { Name = "Michael", IsChecked = false },
                new Model { Name = "Steve", IsChecked = false },
                new Model { Name = "Joel", IsChecked = true }
            };
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class Model : INotifyPropertyChanged
    {
        private string name;
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    RaisePropertyChanged("Name");
                }
            }
        }

        private bool isChecked;
        public bool IsChecked
        {
            get { return isChecked; }
            set
            {
                if (isChecked != value)
                {
                    isChecked = value;
                    RaisePropertyChanged("IsChecked");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}

